//
// Copyright 2019 The ANGLE Project Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.
//

// validationGL33.cpp: Validation functions for OpenGL 3.3 entry point parameters

#include "libANGLE/validationGL33_autogen.h"

namespace gl
{

bool ValidateBindFragDataLocationIndexed(const Context *context,
                                         ShaderProgramID program,
                                         GLuint colorNumber,
                                         GLuint index,
                                         const GLchar *name)
{
    return true;
}

bool ValidateColorP3ui(const Context *context, GLenum type, GLuint color)
{
    return true;
}

bool ValidateColorP3uiv(const Context *context, GLenum type, const GLuint *color)
{
    return true;
}

bool ValidateColorP4ui(const Context *context, GLenum type, GLuint color)
{
    return true;
}

bool ValidateColorP4uiv(const Context *context, GLenum type, const GLuint *color)
{
    return true;
}

bool ValidateGetFragDataIndex(const Context *context, ShaderProgramID program, const GLchar *name)
{
    return true;
}

bool ValidateGetQueryObjecti64v(const Context *context,
                                QueryID id,
                                GLenum pname,
                                const GLint64 *params)
{
    return true;
}

bool ValidateGetQueryObjectui64v(const Context *context,
                                 QueryID id,
                                 GLenum pname,
                                 const GLuint64 *params)
{
    return true;
}

bool ValidateMultiTexCoordP1ui(const Context *context, GLenum texture, GLenum type, GLuint coords)
{
    return true;
}

bool ValidateMultiTexCoordP1uiv(const Context *context,
                                GLenum texture,
                                GLenum type,
                                const GLuint *coords)
{
    return true;
}

bool ValidateMultiTexCoordP2ui(const Context *context, GLenum texture, GLenum type, GLuint coords)
{
    return true;
}

bool ValidateMultiTexCoordP2uiv(const Context *context,
                                GLenum texture,
                                GLenum type,
                                const GLuint *coords)
{
    return true;
}

bool ValidateMultiTexCoordP3ui(const Context *context, GLenum texture, GLenum type, GLuint coords)
{
    return true;
}

bool ValidateMultiTexCoordP3uiv(const Context *context,
                                GLenum texture,
                                GLenum type,
                                const GLuint *coords)
{
    return true;
}

bool ValidateMultiTexCoordP4ui(const Context *context, GLenum texture, GLenum type, GLuint coords)
{
    return true;
}

bool ValidateMultiTexCoordP4uiv(const Context *context,
                                GLenum texture,
                                GLenum type,
                                const GLuint *coords)
{
    return true;
}

bool ValidateNormalP3ui(const Context *context, GLenum type, GLuint coords)
{
    return true;
}

bool ValidateNormalP3uiv(const Context *context, GLenum type, const GLuint *coords)
{
    return true;
}

bool ValidateQueryCounter(const Context *context, QueryID id, QueryType targetPacked)
{
    return true;
}

bool ValidateSecondaryColorP3ui(const Context *context, GLenum type, GLuint color)
{
    return true;
}

bool ValidateSecondaryColorP3uiv(const Context *context, GLenum type, const GLuint *color)
{
    return true;
}

bool ValidateTexCoordP1ui(const Context *context, GLenum type, GLuint coords)
{
    return true;
}

bool ValidateTexCoordP1uiv(const Context *context, GLenum type, const GLuint *coords)
{
    return true;
}

bool ValidateTexCoordP2ui(const Context *context, GLenum type, GLuint coords)
{
    return true;
}

bool ValidateTexCoordP2uiv(const Context *context, GLenum type, const GLuint *coords)
{
    return true;
}

bool ValidateTexCoordP3ui(const Context *context, GLenum type, GLuint coords)
{
    return true;
}

bool ValidateTexCoordP3uiv(const Context *context, GLenum type, const GLuint *coords)
{
    return true;
}

bool ValidateTexCoordP4ui(const Context *context, GLenum type, GLuint coords)
{
    return true;
}

bool ValidateTexCoordP4uiv(const Context *context, GLenum type, const GLuint *coords)
{
    return true;
}

bool ValidateVertexAttribP1ui(const Context *context,
                              GLuint index,
                              GLenum type,
                              GLboolean normalized,
                              GLuint value)
{
    return true;
}

bool ValidateVertexAttribP1uiv(const Context *context,
                               GLuint index,
                               GLenum type,
                               GLboolean normalized,
                               const GLuint *value)
{
    return true;
}

bool ValidateVertexAttribP2ui(const Context *context,
                              GLuint index,
                              GLenum type,
                              GLboolean normalized,
                              GLuint value)
{
    return true;
}

bool ValidateVertexAttribP2uiv(const Context *context,
                               GLuint index,
                               GLenum type,
                               GLboolean normalized,
                               const GLuint *value)
{
    return true;
}

bool ValidateVertexAttribP3ui(const Context *context,
                              GLuint index,
                              GLenum type,
                              GLboolean normalized,
                              GLuint value)
{
    return true;
}

bool ValidateVertexAttribP3uiv(const Context *context,
                               GLuint index,
                               GLenum type,
                               GLboolean normalized,
                               const GLuint *value)
{
    return true;
}

bool ValidateVertexAttribP4ui(const Context *context,
                              GLuint index,
                              GLenum type,
                              GLboolean normalized,
                              GLuint value)
{
    return true;
}

bool ValidateVertexAttribP4uiv(const Context *context,
                               GLuint index,
                               GLenum type,
                               GLboolean normalized,
                               const GLuint *value)
{
    return true;
}

bool ValidateVertexP2ui(const Context *context, GLenum type, GLuint value)
{
    return true;
}

bool ValidateVertexP2uiv(const Context *context, GLenum type, const GLuint *value)
{
    return true;
}

bool ValidateVertexP3ui(const Context *context, GLenum type, GLuint value)
{
    return true;
}

bool ValidateVertexP3uiv(const Context *context, GLenum type, const GLuint *value)
{
    return true;
}

bool ValidateVertexP4ui(const Context *context, GLenum type, GLuint value)
{
    return true;
}

bool ValidateVertexP4uiv(const Context *context, GLenum type, const GLuint *value)
{
    return true;
}

}  // namespace gl
